#include "cgul.h"

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    char* s = NULL;
    cgul_exception_t local = NULL;

    /* Allocate a new string. */
    s = cgul_libc__asprintf(&local, "%s", "Hello, World!");
    if (local) {
        goto out;
    }

    /* Print the string. */
    cgul_libc__printf(&local, "%s\n", s);
    if (local) {
        goto out;
    }

 out:

    /* Catch exceptions. */
    if (local) {
        const char* msg = cgul_exception__get_message(local);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    /* Clean up. */
    if (s) {
        free(s);
    }

    return rv;
}
