#include "cgul.h"

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    unsigned long int i = 0;
    cgul_exception_t local = NULL;

    for (i = 1 ; i <= 64  ; ++i) {
        cgul_libc__printf(&local,
                          "floor(log2(%2lu)) = %d\n",
                          i,
                          cgul_log2__floor(&local, i));
        cgul_libc__printf(&local,
                          " ceil(log2(%2lu)) = %d\n",
                          i,
                          cgul_log2__ceil(&local, i));
        cgul_libc__puts(&local, "");
        if (local) {
            goto out;
        }
    }

 out:

    /* Catch exceptions. */
    if (local) {
        const char* msg = cgul_exception__get_message(local);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    return rv;
}
