#ifndef CGUL_RANDOM_LFG32_P_H
#define CGUL_RANDOM_LFG32_P_H

#include "cgul_common.h"
#include "cgul_random_lfg32.h"

CGUL_BEGIN_C

/**
 * Data encapsulated by the <code>cgul_random_lfg32</code> class.
 */
struct cgul_random_lfg32 {

    /**
     * The vector that holds PRNs that are waiting to be combined.
     */
    cgul_uint32_t* v;

    /**
     * The index into v.
     */
    size_t v_index;

    /**
     * Current value for the Weyl Generator.
     */
    cgul_uint32_t weyl;

};

CGUL_END_C

#endif  /*  CGUL_RANDOM_LFG32_P_H  */
