#include "cgul.h"

int main(int argc, char* argv[])
{
    int rv = 0;
    long int i = 0;
    cgul_exception_t local = NULL;
    cgul_vector_t v = NULL;

    v = cgul_vector__new(&local);
    if (local) {
        goto out;
    }

    for (i = 0 ; i < 1000 ; ++i) {
        cgul_vector__push_back(&local, v, (void*)i);
        if (local) {
            goto out;
        }
    }

    while (cgul_vector__get_size(&local, v) > 0) {
        i = (long int)cgul_vector__pop_back(&local, v);
        cgul_libc__printf(&local, "i = %ld\n", i);
        if (local) {
            goto out;
        }
    }

 out:

    if (local) {
        const char* msg = cgul_exception__get_message(local);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    if (v) {
        cgul_vector__delete(v);
    }

    return rv;
}
